###############################################################################
# TableWrap.pl                                                                #
###############################################################################
# Mod for:    YaBB (Yet another Bulletin Board)                               #
#             Version:  YaBB 2.3.1                                              #
#             Packaged: October 12, 2008                                      #
# =========================================================================== #
# Copyright (c) 2008 Calvin Goodman (Unilat) - All Rights Reserved.           #
###############################################################################

$managecatsplver = 'YaBB 2.3 $Revision: 1.0.0.0.0.0 $';
if ($action eq 'detailedversion') { return 1; }

&LoadLanguage('TableWrap');

sub TableWrapper {
	&is_admin_or_gmod;
	unless ($twrapload == 1) { require "$vardir/tablewrap.txt"; }
	
	fopen(CSS, "$forumstylesdir/tablewrap.css") || &admin_fatal_error("$maintext_23 $forumstylesdir/tablewrap.css : ", 1);
	while ($line = <CSS>) {
		$line =~ s~[\r\n]~~g;
		$line =~ s~&nbsp;~&#38;nbsp;~g;
		$line =~ s~&amp;~&#38;amp;~g;
		&FromHTML($line);
		$twrapcss .= qq~$line\n~;
	}
	fclose(CSS);
	
	$yyjavascript .= qq~
	var templates = new Array();
	var endtemplates = new Array();
	var selected = "";
	var inner = '	<div class="bordercolor" style="padding: 0px; width: 100%; margin-left: 0px; margin-right: auto;">\\n	<table border="0" align="center" cellspacing="1" cellpadding="4" width="100%">\\n	<tr>\\n	    <td class="windowbg2" colspan="2" align="left">\\n	      <span class="small">\\n	      $tablewrap_txt{'1'}\\n	      </span>\\n	    </td>\\n	  </tr>\\n	</table>\\n	</div>';
	~;
	
	my @keys = keys %tablewrap;
	foreach (@keys) {
		$tmp = $tablewrap{$_};
		$tmp =~ s/\'/\\'/g;
		$tmp =~ s/[\r\n]+/\\n/g;
		$yyjavascript .= "templates['$_'] = '$tmp';\n";
		$tmp = $tablewrapend{$_};
		$tmp =~ s/\'/\\'/g;
		$tmp =~ s/[\r\n]+/\\n/g;
		$yyjavascript .= "endtemplates['$_'] = '$tmp';\n";
	}
	
	$yyjavascript .= qq~
	function ChangeTemplate(which) {
		document.getElementById("twraptop").value = templates[which];
		document.getElementById("twrapbot").value = endtemplates[which];
		selected = which;
	}
	function NewTemplate() {
		var temp = document.getElementById("newtemp").value;
		var tempselect = document.getElementById("tempselect");
		if(navigator.appName=="Microsoft Internet Explorer") {
			tempselect.add(new Option(temp,temp));
		} else {
			tempselect.add(new Option(temp,temp),null);
		}
		tempselect.options[tempselect.options.length - 1].selected = true;
		templates[temp] = "";
		endtemplates[temp] = "";
		ChangeTemplate(temp);
	}
	function SendTemplates() {
		var temps = document.getElementById("tempselect").options;
		var sender = document.getElementById("wraptemps");
		var starts = document.getElementById("twrapstart");
		var ends = document.getElementById("twrapend");
		for(var i = 0; i < temps.length; i++) {
			if(temps[i]!=null) {
				sender.value = sender.value + "," + temps[i].value;
				starts.value = starts.value + "<!{-twrapsplitter-}!>" + templates[temps[i].value];
				ends.value = ends.value + "<!{-twrapsplitter-}!>" + endtemplates[temps[i].value];
			}
		}
		document.getElementById("wrapform").submit();
	}
	function DeleteTemplate() {
		if(confirm("Are you sure you want to delete this Wrap?")) {
			var temps = document.getElementById("tempselect");
			var i = temps.selectedIndex;
			var val = temps.options[i].value;
			templates[val] = null;
			endtemplates[val] = null;
			temps.options[i] = null;
			i--;
			if(i<0){i=0;}
			ChangeTemplate(temps.options[i].value);
		}
	}
	function PreviewWrap() {
		var newstyle = document.createElement("style");
		newstyle.type = "text/css";
		if (newstyle.styleSheet) {
		  newstyle.styleSheet.cssText = document.getElementById("twrapcss").value;
		} else {
		  newstyle.appendChild(document.createTextNode(document.getElementById("twrapcss").value));
		}
		document.getElementsByTagName("head")[0].appendChild(newstyle);
		var outer = document.getElementById("outer");
		var top = document.getElementById("twraptop").value;
		var bot = document.getElementById("twrapbot").value;
		outer.innerHTML = top + inner + bot;
	}
	~;

	$yystyle .= qq~<style type="text/css" title="preview"></style>~;

	$yymain .= qq~
<form action="$adminurl?action=tablewrap2" method="post" name="wrapform" id="wrapform">
<div class="bordercolor" style="padding: 0px; width: 99%; margin-left: 0px; margin-right: auto;">
<table border="0" align="center" cellspacing="1" cellpadding="4" width="100%">
  <tr>
    <td class="titlebg" colspan="2" align="left">
      <img src="$imagesdir/cat.gif" alt="" border="0" />
      <b>$tablewrap_txt{'2'}</b>
    </td>
  </tr><tr>
    <td class="windowbg2" width="50%">Enable Table Wrapper?</td>
    <td class="windowbg2" width="50%"><input type="checkbox" name="enabletwrap" value="1" ~ . ($enabletwrap ? "checked='checked'" : "") . qq~ /></td>
  </tr><tr>
    <td class="catbg">$tablewrap_txt{'3'} $tablewrap_txt{'4'}</td>
    <td class="catbg">$tablewrap_txt{'3'} $tablewrap_txt{'5'}</td>
  </tr><tr>
    <td class="windowbg2" align="left">
      <div style="margin-bottom:5px"><input type="text" name="newtemp" id="newtemp" /> <input type="button" value="Create New" onclick="javascript:NewTemplate()" /></div>
      <textarea rows="10" style="width:98%" name="twraptop" id="twraptop" onkeyup="javascript:templates[selected] = this.value">$tablewrap{$keys[0]}</textarea><br />
      $tablewrap_txt{'6'}
      <textarea rows="10" style="width:98%" name="twrapbot" id="twrapbot" onkeyup="javascript:endtemplates[selected] = this.value">$tablewrapend{$keys[0]}</textarea>
    </td>
    <td class="windowbg2" align="center">
      <textarea rows="23" style="width:98%" name="twrapcss" id="twrapcss" wrap="off">$twrapcss</textarea>
    </td>
  </tr><tr>
    <td class="catbg" align="left">$tablewrap_txt{'7'}: 
      <select id="tempselect" onchange="javascript:ChangeTemplate(this.options[this.selectedIndex].value)">~;
      
	foreach (keys %tablewrap) {
		$yymain .= qq~<option value="$_">$_</option>\n~;
	}
      
	$yymain .= qq~
      </select>
      <input type="button" value="$tablewrap_txt{'8'}" onclick="DeleteTemplate()" />
    </td>
    <td class="catbg" align="right">
    <input type="button" onclick="SendTemplates()" value="$tablewrap_txt{'9'}"> <input type="button" onclick="javascript:PreviewWrap()" value="$tablewrap_txt{'10'}">
    <input type="hidden" name="wraptemps" id="wraptemps" />
    <input type="hidden" name="twrapstart" id="twrapstart" />
    <input type="hidden" name="twrapend" id="twrapend" />
    </td>
  </tr>
</table>
</div><br />

<div id="outer" style="width:99%"><script language="javascript1.2" type="text/javascript">document.write(inner);</script></div>
</form>~;

	$yytitle     = "$tablewrap_txt{'2'}";
	$action_area = "tablewrap";
	&AdminTemplate;
}

sub TableWrapper2 {
	&is_admin_or_gmod;
	unless ($twrapload == 1) { require "$vardir/tablewrap.txt"; }
	
	my(@names,@starts,@ends,$twvals,$twevals);
	
	@names  = split(/\,/,$FORM{'wraptemps'});
	@starts = split("<!{-twrapsplitter-}!>",$FORM{'twrapstart'});
	@ends   = split("<!{-twrapsplitter-}!>",$FORM{'twrapend'});
	
	for ($i = 1; $i <= $#names; $i++) {
		$twvals  .= "'$names[$i]' => qq~$starts[$i]~,\n";
		$twevals .= "'$names[$i]' => qq~$ends[$i]~,\n";
	}

	my $setfile = << "EOF";
###############################################################################
# TableWrap.settings                                                          #
###############################################################################

\$twrapload = 1;

\$enabletwrap = qq~$FORM{'enabletwrap'}~;

\%tablewrap = (
$twvals
);

\%tablewrapend = (
$twevals
);

1;
EOF

	fopen(SETTING, ">$vardir/tablewrap.txt") || &admin_fatal_error("$maintext_23 $vardir/tablewrap.txt : ", 1);
	print SETTING $setfile;
	fclose(SETTING);
	
	$FORM{'twrapcss'} =~ tr/\r//d;
	$FORM{'twrapcss'} =~ s~\A\n~~;
	$FORM{'twrapcss'} =~ s~\n\Z~~;
	
	fopen(CSS, ">$forumstylesdir/tablewrap.css") || &admin_fatal_error("$maintext_23 $forumstylesdir/tablewrap.css : ", 1);
	print CSS $FORM{'twrapcss'};
	fclose(CSS);

	$yySetLocation = qq~$adminurl?action=tablewrap~;
	&redirectexit;
}

1;